import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import common.util.CsvUtil;
import dto.Sample001CsvDto;

/**
 * Servlet implementation class TestServlet
 */
@WebServlet("/TestServlet")
public class TestServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public TestServlet() {
        super();
    }

    /**
     * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {


    	Calendar cal = Calendar.getInstance();
        //フォーマットパターンを指定して表示する
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String strDate = sdf.format(cal.getTime());

        // CSV読み込み
		String csvpath = "C:\\pleiades/pl4.6.3_3/pleiades/workspace/web_003/WebContent/input/Sample001.csv" ;
        ArrayList<Sample001CsvDto> dtoList=readSample001Csv(csvpath);

        for(Sample001CsvDto readDto : dtoList){
			System.out.println(readDto.toString());
		}

		// 呼び出し先Jspに渡すデータセット
		request.setAttribute("fromServlet",  "サーブレットで追加 "+ strDate);

		request.setAttribute("dtoList",  dtoList);

		// result.jsp にページ遷移
		RequestDispatcher dispatch = request.getRequestDispatcher("result.jsp");
		dispatch.forward(request, response);
    }

    /**
     * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        // ContentType設定
        response.setContentType("text/html; charset=Shift_JIS");
        // Writer取得
        PrintWriter writer = response.getWriter();
        // HTML作成
        writer.print("<HTML><BODY>");
        writer.print("TestServlet::doPostが実行されました。<BR/>");
        writer.print("</BODY></HTML>");

    }
	public ArrayList<Sample001CsvDto> readSample001Csv(String csvpath) {
		System.out.println("readCsvWithTitle() start");

		String encode = "UTF-8" ;
		String sepa = "," ;
		boolean dquoteFlg = true ;
		boolean commentFlg = false ;
		boolean readTitle = false ;

		ArrayList<Sample001CsvDto> dtoList = new ArrayList<>();

		try {
			List<ArrayList<String>> csvList = CsvUtil.readCsvWithTitle(
				csvpath,
				encode,
				sepa,
				true,
				false,
				false);

			int lineNo = 0;

			for(ArrayList<String> lineList : csvList){
				lineNo++;
				if (lineList.size() != 3){
					System.out.println("カラム数が不正。"+lineNo+ "行目");
					break;
				}
				Sample001CsvDto dto = new Sample001CsvDto();
				dto.setDataType(lineList.get(0));
				dto.setName(lineList.get(1));
				dto.setCounter(lineList.get(2));

				dtoList.add(dto);
			}

		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		System.out.println("readCsvWithTitle() end");
		return dtoList ;

	}

}